var scrolTransmissionUploadingTimer = null;
var UPHOTO_TRANSMISSION_UPLOADING_SCROLLTOP = 0;//传输->上传列表中滚动的像素 单位px
var UPHOTO_TRANSMISSION_UPLOADING_LAST_LOAD_PROCESSING = "";//传输->上传列表中上一个加载页数过程，例如1-2代表从第1页加载到第2页,1-2代表从第1页加载到第2页，防止滚动时重复加载页数
var _transmissionuploadingflag = false;
var UPHOTO_TRANSMISSION_UPLOADING_SINGLE_PAGE_NUM = 100;
var uploadata = {};

// 防抖动
function throttleTransmissionUploading(fn, delay) {
    return function () {
        if (!scrolTransmissionUploadingTimer) {
            scrolTransmissionUploadingTimer = setTimeout(() => {
                fn();
                clearTimeout(scrolTransmissionUploadingTimer);
                scrolTransmissionUploadingTimer = null;
            }, delay)
        }
    }
}

// 计算现在滚动到哪个li元素下了
function calcUploadUploadingListOnWheelPosition() {

    var tmptop = null;
    var resindex = 0;
    var pics = jQuery("#uphoto-transmission-content-lists-content-table-uploading tr");

    var len = pics.length;
    for (var i = 0; i < len; i++) {
        tmptop = pics.eq(i).offset().top;
        if (tmptop >= 0) {
            resindex = pics.eq(i).attr("data-index");
            break;
        }
    }
    return resindex;
}

function getTransmissionUploadingCurrentPagePIcStrUp(listenobjindex) {
    if (listenobjindex <= 0) {
        return "";
    }
	
    // 读取变量中的待上传数据,刷新会丢失
    var totalnum = uploadata != null && uploadata != undefined ? Object.values(uploadata).length : 0;
    if (!totalnum) {
        return "";
    }
    var str = '';
    var index = 0;

    for (let i = totalnum; i >= 0; i--) {
        if (typeof uploadata[i] == 'undefined' || uploadata[i] == null || uploadata[i] == "") {
            continue;
        }

        if (uploadata[i].transtype != "upload" || uploadata[i].finish == 1) {
            continue;
        }

        if (index >= UPHOTO_TRANSMISSION_UPLOADING_SINGLE_PAGE_NUM || uploadata[i].num >= listenobjindex) {
            continue;
        }

        var str1 = '';

        str1 += '<tr id="uphoto-transmission-content-tr-' + uploadata[i].num + '" data-index="' + uploadata[i].num + '">';
        str1 += '<td style="width: 30%;">';
        str1 += '<div class="uphoto-transmission-content-table-name-select">';
        str1 += '<div class="uphoto-transmission-content-table-name-select-box">';
        str1 += '<span ';
        str1 += 'class="uphoto-transmission-content-lists-content-choose uphoto-transmission-content-lists-content-choose-upload uphoto-transmission-content-lists-content-choose-cancel" data-value="' + uploadata[i].num + '"></span>';
        str1 += '<div class="uphoto-transmission-content-lists-content-span">';
        str1 += '<img src="' + uploadata[i].picurl + '" alt=""  onerror="onerror=null;src=\'/apps/photomanager/web/public/dist/web/images/transmission/icon_upload_placeholder.svg\'">';
        str1 += '</div>';
        str1 += '<span ';
        str1 += 'class="uphoto-transmission-content-lists-content-imgname">' + uploadata[i].filename + '</span>';
        str1 += '</div>';
        str1 += '</div>';
        str1 += '</td>';
        str1 += '<td style="width: 15%;"><span class="uphoto-transmission-content-table-item"><span>' + uploadata[i].fileSize + '</span>' + uploadata[i].fileSizeUnit + '</span></td>';
        str1 += '<td style="width: 15%;"><span class="uphoto-transmission-process-speed uphoto-transmission-content-table-item"><span>' + uploadata[i].lastuploadspeed + '</span>' + uploadata[i].lastuploadspeedunit + '</span></td>';
        str1 += '<td style="width: 30%;">';
        str1 += '<div class="uphoto-transmission-process-box">';
        str1 += '<div class="uphoto-transmission-process">';
        str1 += '<span class="uphoto-transmission-process-bar" style="width:' + uploadata[i].progress + '%;"></span>';
        str1 += '</div>';
        str1 += '<span class="uphoto-transmission-process-percent">' + uploadata[i].progress + '%</span>';
        str1 += '</div>';
        str1 += '</td>';
        str1 += '<td style="width: 10%;">';
        str1 += '<div class="uphoto-transmission-content-oprations">';
        if (uploadata[i]['finish'] == -1) {
            str1 += '<span class="uphoto-transmission-content-oprations-options uphoto-transmission-content-oprations-restart uphoto-transmission-content-oprations-options-' + uploadata[i].num + '" onclick="pauseTask(this);"';
        } else {
            str1 += '<span class="uphoto-transmission-content-oprations-options uphoto-transmission-content-oprations-waiting uphoto-transmission-content-oprations-options-' + uploadata[i].num + '" onclick="pauseTask(this);"';
        }

        str1 += 'title="' + UPHOTO_LANGUAGE['UPHOTO_WAITING'] + '" data-value="' + uploadata[i].num + '"></span>';
        str1 += '<span class="uphoto-transmission-content-oprations-delete" onclick="uphotoTransmissionUploadDeleteSingle(this);"';
        str1 += 'title="' + UPHOTO_LANGUAGE['UPHOTO_DELETE'] + '" data-value="' + uploadata[i].num + '"></span>';
        str1 += '</div>';
        str1 += '</td>';
        str1 += '</tr>';

        str = str1 + str;

        index++;

    }

    return str;
}

function getTransmissionUploadingCurrentPagePIcStrDown(listenobjindex, querynum = -1) {
    if (listenobjindex <= 0) {
        return "";
    }

    // 读取变量中的待上传数据,刷新会丢失
    var totalnum = uploadata != null && uploadata != undefined ? Object.values(uploadata).length : 0;
    if (!totalnum) {
        return "";
    }

    var maxnum = (querynum == -1) ? UPHOTO_TRANSMISSION_UPLOADING_SINGLE_PAGE_NUM : querynum;
    var str = '';
    var index = 0;
    for (let i in uploadata) {
        if (typeof uploadata[i] == 'undefined' || uploadata[i] == null || uploadata[i] == "") {
            continue;
        }

        if (uploadata[i].transtype != "upload" || uploadata[i].finish == 1) {
            continue;
        }

        if (index >= maxnum || uploadata[i].num <= listenobjindex) {
            continue;
        }
		
		
		str += '<tr id="uphoto-transmission-content-tr-' + uploadata[i].num + '" data-index="' + uploadata[i].num + '">';
        str += '<td style="width: 30%;">';
        str += '<div class="uphoto-transmission-content-table-name-select">';
        str += '<div class="uphoto-transmission-content-table-name-select-box">';
        str += '<span ';
        str += 'class="uphoto-transmission-content-lists-content-choose uphoto-transmission-content-lists-content-choose-upload uphoto-transmission-content-lists-content-choose-cancel" data-value="' + uploadata[i].num + '"></span>';
        str += '<div class="uphoto-transmission-content-lists-content-span">';
        str += '<img src="' + uploadata[i].picurl + '" alt=""  onerror="onerror=null;src=\'/apps/photomanager/web/public/dist/web/images/transmission/icon_upload_placeholder.svg\'">';
        str += '</div>';
        str += '<span ';
        str += 'class="uphoto-transmission-content-lists-content-imgname">' + uploadata[i].filename + '</span>';
        str += '</div>';
        str += '</div>';
        str += '</td>';
        str += '<td style="width: 15%;"><span class="uphoto-transmission-content-table-item"><span>' + uploadata[i].fileSize + '</span>' + uploadata[i].fileSizeUnit + '</span></td>';
        str += '<td style="width: 15%;"><span class="uphoto-transmission-process-speed uphoto-transmission-content-table-item"><span>' + uploadata[i].lastuploadspeed + '</span>' + uploadata[i].lastuploadspeedunit + '</span></td>';
        str += '<td style="width: 30%;">';
        str += '<div class="uphoto-transmission-process-box">';
        str += '<div class="uphoto-transmission-process">';
        str += '<span class="uphoto-transmission-process-bar" style="width:' + uploadata[i].progress + '%;"></span>';
        str += '</div>';
        str += '<span class="uphoto-transmission-process-percent">' + uploadata[i].progress + '%</span>';
        str += '</div>';
        str += '</td>';
        str += '<td style="width: 10%;">';
        str += '<div class="uphoto-transmission-content-oprations">';
        if (uploadata[i]['finish'] == -1) {
            str += '<span class="uphoto-transmission-content-oprations-options uphoto-transmission-content-oprations-restart uphoto-transmission-content-oprations-options-' + uploadata[i].num + '" onclick="pauseTask(this);"';
        } else {
            str += '<span class="uphoto-transmission-content-oprations-options uphoto-transmission-content-oprations-waiting uphoto-transmission-content-oprations-options-' + uploadata[i].num + '" onclick="pauseTask(this);"';
        }

        str += 'title="' + UPHOTO_LANGUAGE['UPHOTO_WAITING'] + '" data-value="' + uploadata[i].num + '"></span>';
        str += '<span class="uphoto-transmission-content-oprations-delete" onclick="uphotoTransmissionUploadDeleteSingle(this);"';
        str += 'title="' + UPHOTO_LANGUAGE['UPHOTO_DELETE'] + '" data-value="' + uploadata[i].num + '"></span>';
        str += '</div>';
        str += '</td>';
        str += '</tr>';
		
        index++;

    }

    return str;
}

// 传输 -> 上传列表中向上滚动时
let transmissionUploadinghtmlscrollup = async (tmpage, listenobjindex, choosepicindex, endobjindex) => {

    _transmissionuploadingflag = true;
    var str = getTransmissionUploadingCurrentPagePIcStrUp(listenobjindex);

    if (!str) {
        _transmissionuploadingflag = false;
        hideloading();
        return false;
    }

    var lilen = jQuery("#uphoto-transmission-content-lists-content-table-uploading tr").length;
    if (lilen > 1 * UPHOTO_TRANSMISSION_UPLOADING_SINGLE_PAGE_NUM) {
        //最后面的去除
        var pos = (parseInt(endobjindex) - 1);

        jQuery("#uphoto-transmission-content-lists-content-table-uploading #uphoto-transmission-content-tr-" + pos).nextAll().remove();

    }
    //添加到前面
    jQuery("#uphoto-transmission-content-lists-content-table-uploading").prepend(str);
    _transmissionuploadingflag = false;
    hideloading();
    //直接滚动到选择的元素
    document.querySelector("#uphoto-transmission-content-tr-" + choosepicindex).scrollIntoView({
        behavior: "instant",//instant和smooth表示直接滚到底和使用平滑滚动
        //start表示将视口的顶部和元素顶部对齐；center表示将视口的中间和元素的中间对齐；end表示将视口的底部和元素底部对齐；nearest表示就近对齐
        block: "start",
        //start表示将视口的顶部和元素顶部对齐；center表示将视口的中间和元素的中间对齐；end表示将视口的底部和元素底部对齐；nearest表示就近对齐
        inline: "end"
    });
    return true;
}

// 传输->上传列表中向下滚动时
let transmissionUploadinghtmlscrolldown = async (startobjindex, listenobjindex) => {
    _transmissionuploadingflag = true;
    var str = getTransmissionUploadingCurrentPagePIcStrDown(listenobjindex);
    if (!str) {
        _transmissionuploadingflag = false;
        hideloading();
        return false;
    }

    var lilen = jQuery("#uphoto-transmission-content-lists-content-table-uploading tr").length;
    if (lilen > 1 * UPHOTO_TRANSMISSION_UPLOADING_SINGLE_PAGE_NUM) {
        //后面的添加
        jQuery("#uphoto-transmission-content-lists-content-table-uploading").append(str);
        //前面的去除
        jQuery("#uphoto-transmission-content-lists-content-table-uploading #uphoto-transmission-content-tr-" + startobjindex).prevAll().remove();
    } else {
        //后面的添加
        jQuery("#uphoto-transmission-content-lists-content-table-uploading").append(str);
    }
    _transmissionuploadingflag = false;

    hideloading();
}


// 传输->上传列表滚动
function transmissionUploadingListScrollHandle(obj) {
    var nScrollTop = jQuery(obj)[0].scrollTop;
    var nDivHight = jQuery("#uphoto-transmission-content-lists-content-uploading-scrolluu").height(); //父元素的高度
    var nDivTop = jQuery("#uphoto-transmission-content-lists-content-uploading-scrolluu").offset().top; //父元素的高度 相对于文档的纵向坐标

    //
    var totalnum = uploadata != null && uploadata != undefined ? Object.values(uploadata).length : 0;
    if (!totalnum) {
        return;
    }
    //
    if (nScrollTop - UPHOTO_TRANSMISSION_UPLOADING_SCROLLTOP <= 0) {
        // 往上滚动

        var listenobjindex = jQuery("#uphoto-transmission-content-lists-content-table-uploading tr").eq(0).attr("data-index");
        var nowminpage = Math.ceil(listenobjindex / UPHOTO_TRANSMISSION_UPLOADING_SINGLE_PAGE_NUM);
        var scrollprocessstr = nowminpage + "-" + (nowminpage - 1);

        if ((nScrollTop == 0 && scrollprocessstr != UPHOTO_TRANSMISSION_UPLOADING_LAST_LOAD_PROCESSING && !_transmissionuploadingflag) || (!_transmissionuploadingflag && jQuery("#uphoto-transmission-content-tr-" + listenobjindex).offset().top >= -400 && scrollprocessstr != UPHOTO_TRANSMISSION_UPLOADING_LAST_LOAD_PROCESSING)) {
            // 应该加载上一页
            var endobjindex = jQuery("#uphoto-transmission-content-lists-content-table-uploading tr").eq(-UPHOTO_TRANSMISSION_UPLOADING_SINGLE_PAGE_NUM).attr("data-index");

            var dataindex = calcUploadUploadingListOnWheelPosition(); // 计算现在滚动到哪个li元素下了
            _transmissionuploadingflag = false;
            UPHOTO_TRANSMISSION_UPLOADING_LAST_LOAD_PROCESSING = scrollprocessstr;
            transmissionUploadinghtmlscrollup((nowminpage - 1), listenobjindex, dataindex, endobjindex);
            nScrollTop = jQuery(obj)[0].scrollTop;

        } else {
            UPHOTO_TRANSMISSION_UPLOADING_SCROLLTOP = nScrollTop;
            return true;
        }
    } else {
        // 往下滚动
        var listenobjindex = jQuery("#uphoto-transmission-content-lists-content-table-uploading tr").eq(-1).attr("data-index");
        //
        var nowminpage = Math.ceil((parseInt(listenobjindex) + 1) / UPHOTO_TRANSMISSION_UPLOADING_SINGLE_PAGE_NUM);
        var startobjindex = jQuery("#uphoto-transmission-content-lists-content-table-uploading tr").eq(UPHOTO_TRANSMISSION_UPLOADING_SINGLE_PAGE_NUM).attr("data-index");

        var scrollprocessstr = nowminpage + "-" + (nowminpage + 1);
        if (!_transmissionuploadingflag && (nDivHight + nDivTop + 400) >= jQuery("#uphoto-transmission-content-tr-" + listenobjindex).offset().top && scrollprocessstr != UPHOTO_TRANSMISSION_UPLOADING_LAST_LOAD_PROCESSING) {
            // 应该加载下一页
            UPHOTO_TRANSMISSION_UPLOADING_LAST_LOAD_PROCESSING = scrollprocessstr;
            transmissionUploadinghtmlscrolldown(startobjindex, listenobjindex);
            nScrollTop = jQuery(obj)[0].scrollTop;

        } else {
            //
            UPHOTO_TRANSMISSION_UPLOADING_SCROLLTOP = nScrollTop;
            return true;
        }
    }
    UPHOTO_TRANSMISSION_UPLOADING_SCROLLTOP = nScrollTop;
}



//监听传输->上传列表中滚动事件,使用节流思想，防止滚动事件频繁触发
var transmissionuploadingscrollistener = document.getElementById('uphoto-transmission-content-lists-content-uploading-scrolluu');
transmissionuploadingscrollistener.addEventListener('wheel', throttleTransmissionUploading(() => {
	transmissionUploadingListScrollHandle(transmissionuploadingscrollistener);
	// console.log("传输->上传列表详情滚动");
}, 100), false);